package com.gic.haoban.manage.api.service;

import java.util.List;
import java.util.Set;

import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.manage.api.dto.*;

public interface WxEnterpriseApiService {

	/**
	 * 接收企业回调信息
	 * @param dto
	 */
	void callbackReviceEnterprise(QywxCorpInfoSimpleDTO dto);
	/**
	 * 运维后台获取微信企业id列表
	 * @return
	 */
	com.gic.api.base.commons.Page<YwWxEnterpriseDTO> list(BasePageInfo pageInfo,String keyword,List<String> enterpriseIds,Integer gicContactFlag,String version);
	/**
	 * 获取一个
	 * @param wxEnterpriseId
	 * @return
	 */
	WxEnterpriseDTO getOne(String wxEnterpriseId);

	WxEnterpriseDTO getEnterpriseBycorpId(String corpId);
	/**
	 * 更新企业
	 * @param enterpriseDTO
	 */
	void update(WxEnterpriseDTO enterpriseDTO);
	
	List<YwWxEnterpriseDTO> listAll();
	
	List<YwWxEnterpriseDTO> listByIds(Set<String> enterpriseIds);
	
	boolean enterpriseIsOver(String enterpriseId);

	/**
	 * 获取配置
	 * @param wxEnterpriseId
	 * @param secretType
	 * @param enterpriseId
	 * @return
	 */
	public SecretSettingDTO getSecretSetting(String wxEnterpriseId,int secretType,String enterpriseId);

	/**
	 * 保存
	 * @param secretSettingDTO
	 * @return
	 */
	public boolean saveSecretSetting(SecretSettingDTO secretSettingDTO);

	/**
	 * secretList
	 * @param wxEnterpriseId
	 * @return
	 */
	List<SecretSettingDTO> listSecret(String wxEnterpriseId);

	/**
	 * 删除
	 * @param secretId
	 * @return
	 */
	public boolean delSecretSetting(String secretId);

	/**
	 * 保存小程序配置
	 *
	 * @param miniprogramSettingDTO
	 * @return
	 */
	public boolean saveMiniprogramSetting(MiniprogramSettingDTO miniprogramSettingDTO);


	/**
	 * 查询小程序配置列表
	 *
	 * @param wxEnterpriseId
	 * @return
	 */
	public List<MiniprogramSettingDTO> listMiniprogramSetting(String wxEnterpriseId);

	/**
	 * 获取单个小程序配置
	 *
	 * @param wxEnterpriseId
	 * @param enterpriseId
	 * @return
	 */
	public MiniprogramSettingDTO getMiniprogramSettingByEid(String wxEnterpriseId, String enterpriseId);

	/**
	 * 删除 小程序配置
	 *
	 * @return
	 */
	public boolean delMiniprogramSettingByEid(String id);

	/**
	 * @param dto
	 * @return
	 */
	public boolean saveWelcome(WelcomeDTO dto);

	/**
	 * 获取欢迎语
	 *
	 * @param wxEnterpriseId
	 * @return
	 */
	public WelcomeDTO getWelcome(String wxEnterpriseId);

	/**
	 * 获取欢迎语
	 *
	 * @param wxEnterpriseId
	 * @return
	 */
	public boolean setWelcome(String wxEnterpriseId, Integer openFlag);

	/**
	 * 获取欢迎语
	 *
	 * @param wxEnterpriseId
	 * @return
	 */
	public boolean delWelcome(String wxEnterpriseId);
}
