package com.gic.haoban.manage.service.service;

import com.gic.api.base.commons.Page;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.manage.api.dto.StoreOrGroupInfoDTO;
import com.gic.haoban.manage.service.entity.TabStoreRange;
import com.gic.haoban.manage.service.entity.TabStoreRelation;

import java.util.List;

/**
 * Created 2021/4/9.
 *
 * @author hua
 */
public interface StoreRangeService {
    /**
     * 保存企业的关联关系
     *
     * @param relations
     * @param enterpriseId
     * @param wxEnterpriseId
     * @return
     */
    public boolean saveStoreRange(List<StoreOrGroupInfoDTO> relations, String enterpriseId, String wxEnterpriseId);

    /**
     * 绑定列表
     *
     * @param enterpriseId
     * @param wxEnterpriseId
     * @return
     */
    public List<StoreOrGroupInfoDTO> queryBindStoreRange(String enterpriseId, String wxEnterpriseId);

    /**
     * 获取商户所有绑定列表
     *
     * @param enterpriseId
     * @return
     */
    public List<TabStoreRange> queryAllBindRangeByEnterpriseId(String enterpriseId);

    /**
     * 删除分组id
     *
     * @param enterpriseId
     * @param relationId
     * @return
     */
    public boolean delStoreRangeByRelationId(String enterpriseId, String relationId);

    /**
     * 删除门店
     *
     * @param enterpriseId
     * @param storeId
     * @return
     */
    public boolean delStoreRelationByStoreId(String enterpriseId, String storeId);

    /**
     * 获取商户所有绑定列表 搜索
     *
     * @param enterpriseId
     * @param wxEnterpriseId
     * @param search
     * @param pageInfo
     * @return
     */
    public Page<TabStoreRelation> pageStoreRelation(String enterpriseId, String wxEnterpriseId, String search, BasePageInfo pageInfo);

    /**
     * 保存门店的绑定关联关系
     *
     * @param list
     * @return
     */
    public boolean saveStoreRelations(List<TabStoreRelation> list, String optStaffId, int channelCode);

    /**
     * 删除分组id
     *
     * @param enterpriseId
     * @param relationIds
     * @return
     */
    public List<TabStoreRange> queryStoreRangeByRelationId(String enterpriseId, List<String> relationIds);

    /**
     * 列表
     *
     * @param wxEnterpriseId
     * @param enterpriseId
     * @return
     */
    public List<String> listStoreIdByWxEnterpriseId(String wxEnterpriseId, String enterpriseId);


}
