package com.gic.haoban.manage.service.service.impl;

import java.util.Date;
import java.util.List;

import com.github.pagehelper.PageInfo;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.haoban.common.utils.EntityUtil;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.api.dto.MaterialDTO;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanMaterialMapper;
import com.gic.haoban.manage.service.entity.TabHaobanMaterial;
import com.gic.haoban.manage.service.service.MaterialService;
import com.github.pagehelper.Page;

@Service
public class MaterialServiceImpl implements MaterialService {
	
	@Autowired
	private TabHaobanMaterialMapper mapper;

	@Override
	public List<MaterialDTO> listMaterialByCategoryId(String categoryId) {
		return EntityUtil.changeEntityListByJSON(MaterialDTO.class, mapper.listMaterialByCategoryId(categoryId));
	}

	@Override
	public void insertMaterial(MaterialDTO materialDTO) {
		materialDTO.setCreateTime(new Date());
		materialDTO.setUpdateTime(materialDTO.getCreateTime());
		materialDTO.setStatusFlag(1);
		materialDTO.setMaterialId(StringUtil.randomUUID());
		mapper.insert(EntityUtil.changeEntityByJSON(TabHaobanMaterial.class, materialDTO));
		
	}

	@Override
	public MaterialDTO selectMaterialById(String materialId) {
		return EntityUtil.changeEntityByJSON(MaterialDTO.class, mapper.selectByPrimaryKey(materialId));
	}

	@Override
    public List<MaterialDTO> listMaterialByIds(List<String> materialIds) {
        return EntityUtil.changeEntityListByOrika(MaterialDTO.class, mapper.listByids(materialIds));
    }

    @Override
    public void edit(MaterialDTO materialDTO) {
        materialDTO.setUpdateTime(new Date());
        mapper.updateByPrimaryKeySelective(EntityUtil.changeEntityByJSON(TabHaobanMaterial.class, materialDTO));
//
//        List<TabHaobanMaterial> materials = mapper.listByfromMaterialId(materialDTO.getMaterialId());
//        if (CollectionUtils.isEmpty(materials)) {
//
//            return;
//        }

    }

	@Override
	public Page<TabHaobanMaterial> listMaterial(String wxEnterpriseId, String keyword, String categoryId, Integer materialType) {
		return mapper.listMaterial(wxEnterpriseId,keyword,categoryId,materialType);
	}

	@Override
	public Page<TabHaobanMaterial> listMaterial(String wxEnterpriseId, String keyword, List<String> categoryIds, Integer materialType) {
		List<TabHaobanMaterial> materials = mapper.listMaterialByCategoryIds(wxEnterpriseId, keyword, categoryIds, materialType);
		return (Page) materials;
	}

	@Override
	public MaterialDTO getMaterialByFromMaterialId(String fromMaterialId, String wxEnterpriseId) {
        TabHaobanMaterial tabHaobanMaterial = mapper.selectByfromMaterialId(fromMaterialId, wxEnterpriseId);
        return EntityUtil.changeEntityByJSON(MaterialDTO.class, tabHaobanMaterial);
    }

	@Override
	public List<MaterialDTO> listMaterialByFromMateralId(String fromMaterialId) {
		List<TabHaobanMaterial> list = mapper.listByfromMaterialId(fromMaterialId);
		return EntityUtil.changeEntityListByOrika(MaterialDTO.class, list);
	}

	@Override
	public void delmaterialByIds(List<String> ids) {
		mapper.delMaterialByIds(ids);
	}
}
