package com.gic.haoban.manage.web.controller;

import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.gic.clerk.api.service.ClerkService;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.MaidianLogDTO;
import com.gic.haoban.manage.api.service.MaidianLogApiService;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;

@RestController
public class MaidianLogController extends WebBaseController{
	
	@Autowired
	private MaidianLogApiService maidianLogApiService;
	@Autowired
	private ClerkService clerkService;
	@Autowired
	private StoreService storeService;
	
	@RequestMapping("save-maidian-log")
	public HaobanResponse saveUserLoginLog(String maidianLogStr) {
		if(StringUtils.isBlank(maidianLogStr)){
			return resultResponse(HaoBanErrCode.ERR_2);
		}
		List<MaidianLogDTO> maidianLogDTOList = JSON.parseArray(maidianLogStr,MaidianLogDTO.class);
		for (MaidianLogDTO maidianLogDTO : maidianLogDTOList) {
			String options = maidianLogDTO.getOptions();
			if(StringUtils.isNotBlank(options) && options.length() > 2000){
				maidianLogDTO.setOptions(options.substring(0,1999));
			}
			StoreDTO store = storeService.getStore(maidianLogDTO.getStoreId());
			if(store != null){
				com.gic.clerk.api.dto.ClerkDTO clerkDTO = clerkService.getClerkByClerkCode(store.getEnterpriseId(), maidianLogDTO.getClerkCode());
				maidianLogDTO.setEnterpriseId(store.getEnterpriseId());
				if(clerkDTO != null){
					maidianLogDTO.setClerkId(clerkDTO.getClerkId());
				}
			}
			maidianLogApiService.insert(maidianLogDTO);
		}
		return resultResponse(HaoBanErrCode.ERR_1);
		
	}

}
